#include <bits/stdc++.h>
using namespace std;
int main(){
ios_base::sync_with_stdio(false);
cin.tie(0);
int n,k,x;
cin>>n>>k>>x;
int a[n];
int ikspola;
int brojac =1;
if((k==0)||(k>n*(n-1)/2)){
    for(int i=0;i<n;i++){
    a[i]=1;
    cout<<a[i]<<" ";
    }
    return 0;
}
if(n==1){
    if(k==0){cout<<1;}
    else{
        cout<<-1;
        return 0;
    }
}
if(k==3){
        if(n<3){cout<<-1; return 0;}
        if(n==3){cout<<1<<" "<<x+1<<" "<< 2*x+1; return 0;}
        ikspola=n-4;
        a[0]=1;
        cout<<a[0]<<" ";
       while(ikspola){
            a[brojac]=x/2+1;
            cout<<a[brojac]<< " ";
            brojac++;
            ikspola--;
       }
       for(int i=brojac;i<n;i++){
       a[i]=x+1;
       if(i!=n-1)cout<<a[i]<<" ";
        else cout<<a[i];

       }
       return 0;
       }
    if(k==n){

        if(n==1) {cout<<1; return 0;}
        if(n==2) {cout<<-1; return 0;}
        a[0]=1;
        int pomocniks=a[0]+x;
        a[1]=pomocniks;
        int pom=n-3;
        int broj=2;
        while(pom){
            a[broj]=pomocniks+1;
            broj++;
            pom--;
        }
        a[n-1]=pomocniks+x;
        for(int i=0;i<n;i++){
                if(i!=n-1)cout<<a[i]<<" ";
        else cout<<a[i];


       }
       return 0;
}
if(k<n){

        /*if(n<3){cout<<-1; return 0;}
        if(n==3){cout<<1<<" "<<x+1<<" "<< 2*x+1; return 0;}*/
        ikspola=n-1-k;
        a[0]=1;
        cout<<a[0]<<" ";
       while(ikspola){
            a[brojac]=x/2+1;
            cout<<a[brojac]<< " ";
            brojac++;
            ikspola--;
       }
       for(int i=brojac;i<n;i++){
       a[i]=x+1;
       if(i!=n-1)cout<<a[i]<<" ";
        else cout<<a[i];

       }
       return 0;
       }

    if(k==n*(n-1)/2){

    a[0]=1;
        for(int i=1;i<n;i++){
            a[i]=a[i-1]+x;

        }
         for(int i=0;i<n;i++){
                if(i!=n-1)cout<<a[i]<<" ";
        else cout<<a[i];


       }
       return 0;
    }
    if(k>n){
        if(n==1) {cout<<-1;return 0;}

        int brojrazlicitih=k-n;
        int brojistih=n-brojrazlicitih;
        a[0]=1;
        int helpbrojac=1;
        while(brojistih){
                a[helpbrojac]=1;
                helpbrojac++;
                brojistih--;

        }
        for(int i=helpbrojac;i<n;i++){
            a[i]=a[i-1]+x;


        }
         for(int i=0;i<n;i++){

                if(i!=n-1)cout<<a[i]<<" ";
                 else cout<<a[i];


       }
       return 0;
    }

}